#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>

#define BUFSIZE 4096

struct _msgAck
{
	char filename[256];
	int  totalsize;
	int  offset;
};

struct _msgData
{
	char filename[256];
	int  totalsize;
	int  offset;
	char buf[BUFSIZE];
	int  datasize;
};

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

int main(int argc, char* argv[])
{
	int retval;
	printf("  ȭ udp   ְ ޴ .\n");
	printf("Ҿ.. θ䳢  .. orz.. 3D ù JLPT .. \n");
	//  ʱȭ
	WSADATA wsa;
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		return -1;

	// socket()
	SOCKET sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");	
	
	// bind()
	SOCKADDR_IN serveraddr;
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(9000);
	serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
	retval = bind(sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR) err_quit("bind()");
	
	_msgData msgData;
	_msgAck msgAck;
	FILE *fp;
	int numtotal;
	SOCKADDR_IN peeraddr;
	int peerlen;
	
	while(1)
	{
		//  ߺ  ̾ޱ  ˻.
		peerlen = sizeof(peeraddr);
		retval = recvfrom(sock, (char *)&msgData, sizeof(msgData), 0, 
			(SOCKADDR *)&peeraddr, &peerlen);
		if(retval == SOCKET_ERROR)
		{
			err_display("recvfrom()");
			break;
		}
		else
		{
			memcpy(msgAck.filename, msgData.filename, sizeof(msgData.filename));
			msgAck.totalsize = msgData.totalsize;

			FILE *fp;
			if((fp = fopen(msgData.filename, "rb")) != NULL)		//  .
			{																		//   ̹   ִٸ
				fseek(fp, 0, SEEK_END);									//     ġ ͸ ű
				msgAck.offset = numtotal = (int)ftell(fp);											//  ġ Ѵ.. ̾ޱ⸦ ϱ ó
				fclose(fp);
			}
			else
				msgAck.offset = numtotal = 0;
		}

		retval = sendto(sock, (char *)&msgAck, sizeof(msgAck), 0, 
			(SOCKADDR *)&peeraddr, sizeof(peeraddr));
		if(retval == SOCKET_ERROR)
		{
			err_display("sendto()");
			break;
		}
		if(msgAck.totalsize == msgAck.offset)
		{
			printf("Client IP=[%s], Port=[%d], %s   öԽϴ.\n\n",
				inet_ntoa(peeraddr.sin_addr), ntohs(peeraddr.sin_port), msgAck.filename);
			continue;
		}

		//////////////////////////////////   ޴ ƾ //////////////////////////////////
		while(1)
		{
			//  ޱ
			peerlen = sizeof(peeraddr);
			retval = recvfrom(sock, (char *)&msgData, sizeof(msgData), 0, 
				(SOCKADDR *)&peeraddr, &peerlen);
			if(retval == SOCKET_ERROR)
			{
				err_display("recvfrom()");
				break;
			}

			if(msgData.offset != numtotal)
			{
				printf("[] ùٸ Ͱ ƴմϴ. offset = %d, numtotal = %d\n", 
					msgData.offset, numtotal);
				memcpy(msgAck.filename, msgData.filename, sizeof(msgData.filename));
				msgAck.totalsize = msgData.totalsize;
				msgAck.offset = numtotal;								//   ϴ ġ 
				retval = sendto(sock, (char *)&msgAck, sizeof(msgAck), 0, 
					(SOCKADDR *)&peeraddr, sizeof(peeraddr));
				if(retval == SOCKET_ERROR)
				{
					err_display("sendto()");
					break;
				}
				printf("Ack  = %d\n", msgAck.offset);
				continue;
			}
	//		else
	//			printf("-> Offset = %d, numtotal = %d\n", msgData.offset, numtotal);

			if(!numtotal)
			{
				printf("Client IP=[%s], Port=[%d], %s  ø ֽϴ.\n",
					inet_ntoa(peeraddr.sin_addr), ntohs(peeraddr.sin_port), msgAck.filename);
				printf("->   ̸: %s\n", msgData.filename);
				printf("->   ũ: %d Ʈ\n", msgData.totalsize);
			}
			fp = fopen(msgData.filename, "ab");
			if(fp == NULL)
			{
				perror("");
				break;
			}
			fwrite(msgData.buf, 1, msgData.datasize, fp);
			if(ferror(fp))
			{
				perror("");
				break;
			}
			fclose(fp);
			// ACK 
			memcpy(msgAck.filename, msgData.filename, sizeof(msgData.filename));
			msgAck.totalsize = msgData.totalsize;
			msgAck.offset = msgData.offset;
			retval = sendto(sock, (char *)&msgAck, sizeof(msgAck), 0, 
				(SOCKADDR *)&peeraddr, sizeof(peeraddr));
			if(retval == SOCKET_ERROR)
			{
				err_display("sendto()");
				break;
			}
	//		printf("Ack  = %d\n", msgAck.offset);

			numtotal += msgData.datasize;
			if(numtotal == msgData.totalsize)
				break;
		}

		if(numtotal)
		{
			if(numtotal == msgData.totalsize)
				printf("Client IP=[%s], Port=[%d], %s   Ϸ: %d Ʈ\n\n",
				inet_ntoa(peeraddr.sin_addr), ntohs(peeraddr.sin_port), msgData.filename. msgData.totalsize);
			else if(numtotal > msgData.totalsize)
				printf("->   \\nn");
		}
	}

	// closesocket()
	closesocket(sock);

	//  
	WSACleanup();
	return 0;
}